function clear_dynare_oo_structure()
% function clear_dynare_oo_structure()
% auxiliary function which clears specific fields of DYNARE oo_ structure
%
% INPUTS
%   none
%
% OUTPUTS
%   none
%
% SPECIAL REQUIREMENTS
%   none

% Copyright (C) 2003-2018 Dynare Team
%
% This file is part of Dynare.
%
% Dynare is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
%
% Dynare is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with Dynare.  If not, see <http://www.gnu.org/licenses/>.

global oo_;

clear_field('SmoothedVariables');
clear_field('SmoothedShocks');
clear_field('UpdatedVariables');
clear_field('FilteredVariables');

    function clear_field(fname)
    if(isfield(oo_, fname))
        oo_ = rmfield(oo_, fname);
    end
    end
end
